### __How-To use this Project__

1. Download and install [Visual Studio Code](https://code.visualstudio.com/download) 
2. Install [PlatformIO IDE extension](https://platformio.org/install/ide?install=vscode) for Visual Studio Code 
3. Download sources from master branch, "zip" or "git clone"
4. Create [wifi_credentials.h](include/wifi_credentials.h) from [templ_wifi_credentials.h](include/templ_wifi_credentials.h) in include/

```cpp
#ifndef __WIFI_CREDENTIALS_H
#define __WIFI_CREDENTIALS_H

#ifndef STASSID
#define STASSID "ssid"
#define STAPSK  "key"
#endif

#endif // __WIFI_CREDENTIALS_H
```

5. Create [platformio.ini](platformio.ini) from [templ_platformio_ini](templ_platformio_ini)

```sh
$ cp templ_platformio_ini platformio.ini
```

6. __Uploading new firmware__

```sh
# upload program via ota
$ pio run -t upload
# upload file system via ota
$ pio run -t uploadfs

# upload program via Serial Port
# Serial Port needs to be selected in platformio.ini
$ pio run -t upload -e serial
# upload file system via Serial Port
$ pio run -t uploadfs -e serial
```

------

Additional used sources and  libraries in this project and [DOKU.md](DOKU.md)
- https://arduino-esp8266.readthedocs.io/en/latest/ota_updates/readme.html
- https://github.com/NachtRaveVL/PCA9685-Arduino
- https://arduino-esp8266.readthedocs.io/en/latest/gdb.html
- check different environments inside [platformio.ini](platformio.ini)
